/**
 * 入口文件
 */ 

// base style
import "allsome-less-reset"
import "allsome-less-scaffolding"

import React, {
    Component
} from 'react'
import { render } from 'react-dom'

import {
    HashRouter as Router,
    Route
} from 'react-router-dom'

// 配置文件
import global from 'global';

// 通用组件
import Alert from 'allsome-react-alert';
import Confirm from 'allsome-react-confirm';
import Loading from 'allsome-react-loading';
import Toast from 'allsome-react-toast';


// 页面compponent
import Main from './pages/main'

// less
import Style from "./style.less"

// fetch
import FetchReact from "allsome-fetch/react.component"

// wrapper
class Wrapper extends Component {
    constructor (props) {
        super(props)

    }
    componentWillUnmount () {
        // 切换页面的时候，清除弹框
        this.props.loading.hide()
        this.props.confirm.hide()
        this.props.alert.hide()
        this.props.toast.hide()
        this.props.fetch.clearRequest()
    }
    render () {
        let props = Object.assign({}, this.props)


        return (
            <div className={Style['scroll']} data-scroll>
            {
                React.cloneElement(this.props.children, props)
            }
            </div>
        )
    }
}

class Basic extends Component {
    
    constructor (props) {
        super(props)

        this.state = {
            mounted : false
        }
    }
    wrapperPage (Page) {

        if(!this.state.mounted) return null;

 
        return (
            <Wrapper 
                loading={this.loading} 
                confirm={this.confirm} 
                alert={this.alert} 
                toast={this.toast} 
                fetch={this.fetch}>
                <Page/>
            </Wrapper>
        )

    }
    componentDidMount () {
        this.setState({
            mounted : true
        })

        
    }


    
    render () {

        return (
            <section>
                
                <Alert ref={n=>this.alert=n}/>
                <Confirm ref={n=>this.confirm=n}/>
                <Loading ref={n=>this.loading=n}/>
                <Toast ref={n=>this.toast=n}/>
                <FetchReact ref={n=>this.fetch=n}/>


                <Router>
                    <div>

                        <Route exact path="/" render={() => this.wrapperPage(Main)}/>

                    </div>
                </Router>

            </section>
        )
    }

}




// 启动页面
document.addEventListener('DOMContentLoaded', function(){
    render(<Basic/>, document.getElementById('app'));
})